﻿
/**
 *	EdgeInterface
 */

package {
	
	import flash.geom.Point;
	
	import VectorPoint;
	
	public interface IEdge{
		
		function setControls( _p0:Point , _p1:Point , _p2:Point ):void;
		
		function get p0x():Number;
		function get p0y():Number;
		function get p1x():Number;
		function get p1y():Number;
		function get p2x():Number;
		function get p2y():Number;
		
		/**
		 *	線上の位置を取得
		 *	@param ｔ(0<=t<=1)
		 */
		function getPosAt( t:Number ):Point;
		
		/**
		 *	線微分
		 *	@param ｔ(0<=t<=1)
		 */
		function getDeffAt( t:Number ):Point;
		
		/**
		 *	線座標・ベクトル
		 *	@param ｔ(0<=t<=1)
		 */
		function getVectorPointAt( t:Number ):VectorPoint;
		
		
		/**
		 *	線の長さ
		 */
		function get length():Number;
		
		/**
		 *	直線かどうか
		 */
		function get isLine():Boolean;
	}
	
}